(***********************************************************************)
(*                                                                     *)
(*                              OCamlGen                               *)
(*                                                                     *)
(*                       OCaml module Generator                        *)
(*                                                                     *)
(*               EPI Pomdapi, INRIA Paris - Rocquencourt               *)
(*                                                                     *)
(*  Copyright 1997-2014 INRIA.                                         *)
(*  Institut National de Recherche en Informatique et en Automatique.  *)
(*  All rights reserved. This file is distributed only by permission.  *)
(*                                                                     *)
(*  Pierre Weis <Pierre.Weis@inria.fr>                                 *)
(*                                                                     *)
(***********************************************************************)

(* $Id: symbol.ml,v 1.7 2014/01/31 09:51:52 fclement Exp $ *)

(**

 Generating variable names according to their type.

 These variables are used in patterns as field variables, constructors
 argument, or tuple components.

*)
let variables = Hashtbl.create 23;;
let reset () = Hashtbl.clear variables;;

let is_new sym =
  not (Hashtbl.mem variables sym) &&
  (Hashtbl.add variables sym sym; true)
;;

let rec gen_sym s i =
  let sym = s ^ string_of_int i in
  if is_new sym then sym else gen_sym s (i + 1)
;;

let make s = if is_new s then s else gen_sym s 0;;

let create () = make "x";;
