(***********************************************************************)
(*                                                                     *)
(*                              OCamlGen                               *)
(*                                                                     *)
(*                       OCaml module Generator                        *)
(*                                                                     *)
(*               EPI Pomdapi, INRIA Paris - Rocquencourt               *)
(*                                                                     *)
(*  Copyright 1997-2014 INRIA.                                         *)
(*  Institut National de Recherche en Informatique et en Automatique.  *)
(*  All rights reserved. This file is distributed only by permission.  *)
(*                                                                     *)
(*  Pierre Weis <Pierre.Weis@inria.fr>                                 *)
(*                                                                     *)
(***********************************************************************)

(* $Id: lib_output.mli,v 1.11 2014/01/31 09:51:52 fclement Exp $ *)

(** Runtime library for pretty-outputers generated with OCamlGen. *)

open Format_printer;;

val output_unit : unit Format_printer.printer;;
val output_bool : bool printer;;
val output_quoted_string : string printer;;
val output_quoted_char : char printer;;
val output_quoted_int : int printer;;
val output_quoted_int32 : int32 printer;;
val output_quoted_int64 : int64 printer;;
val output_quoted_nativeint : nativeint printer;;
val output_quoted_float : float printer;;

val output_Couple : ('a, 'b, ('a * 'b)) printer_lifter2;;
val output_Triple : ('a, 'b, 'c, ('a * 'b * 'c)) printer_lifter3;;
val output_List : ('a, 'a list) printer_lifter;;
val output_Array : ('a, 'a array) printer_lifter;;
val output_Option : ('a, 'a option) printer_lifter;;
val output_Ref : ('a, 'a ref) printer_lifter;;

val output_fun : ('a, 'b, ('a -> 'b)) printer_lifter2;;

val output_poly : 'a printer;;
val output_abstract : 'a printer;;
val output_external : 'a printer;;

val output_couple :
  (unit, Format.formatter, unit) format ->
  ('a, 'b, ('a * 'b)) printer_lifter2
;;
val output_triple :
  (unit, Format.formatter, unit) format ->
  ('a, 'b, 'c, ('a * 'b * 'c)) printer_lifter3
;;
val output_list :
  (unit, Format.formatter, unit) format ->
  ('a, 'a list) printer_lifter
;;
val output_array :
  (unit, Format.formatter, unit) format ->
  ('a, 'a array) printer_lifter
;;
val output_option :
  (unit, Format.formatter, unit) format ->
  ('a, 'a option) printer_lifter
;;
val output_ref :
  (unit, Format.formatter, unit) format ->
  ('a, 'a ref) printer_lifter
;;
